using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Systems.Sessions;

[Route(Navigation.Management.Hosts.Systems.Sessions.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostSessionEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Sessions｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Sessions", href: "#", true));
    }

    private async Task<TableData<HostSessionEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostSessionEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostSessionEntity>.Filter.Regex(x => x.Sid, regex) |
                    Builders<HostSessionEntity>.Filter.Regex(x => x.User, regex) |
                    Builders<HostSessionEntity>.Filter.Regex(x => x.Remote, regex) |
                    Builders<HostSessionEntity>.Filter.Regex(x => x.Type, regex) |
                    Builders<HostSessionEntity>.Filter.Regex(x => x.State, regex);
            }

            var query = Database.HostSession()
                .Find(filter)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Sid" => Builders<HostSessionEntity>.Sort.Ascending(p => p.Sid),
                        "User" => Builders<HostSessionEntity>.Sort.Ascending(p => p.User),
                        "Remote" => Builders<HostSessionEntity>.Sort.Ascending(p => p.Remote),
                        "Type" => Builders<HostSessionEntity>.Sort.Ascending(p => p.Type),
                        "State" => Builders<HostSessionEntity>.Sort.Ascending(p => p.State),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Sid" => Builders<HostSessionEntity>.Sort.Descending(p => p.Sid),
                        "User" => Builders<HostSessionEntity>.Sort.Descending(p => p.User),
                        "Remote" => Builders<HostSessionEntity>.Sort.Descending(p => p.Remote),
                        "Type" => Builders<HostSessionEntity>.Sort.Descending(p => p.Type),
                        "State" => Builders<HostSessionEntity>.Sort.Descending(p => p.State),
                        _ => null
                    },
                    _ => Builders<HostSessionEntity>.Sort.Ascending(p => p.Sid)
                });

            return new TableData<HostSessionEntity>()
            {
                TotalItems = (int)await query.CountDocumentsAsync(default),
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostSessionEntity>();
        }
    }
}